#include "stdio.h"
#include "mraa.h"
#include <string.h>
#include <unistd.h>
void msdelay(unsigned int msec)
{    
    long l_pause;   
    clock_t now,then;   
    l_pause = msec*(CLOCKS_PER_SEC/1000);   
    now = then = clock();  
    while( (now-then) < l_pause )   now = clock();
}
int main(int argc, char** argv)
{
    mraa_uart_context uart;
    uart = mraa_uart_init(0);
    char buffer[20] = "AT\r";
    unsigned int rev=0;
    char buff[255]="";
    char *buffptr;
    int i=0;
    if (uart == NULL) {
        fprintf(stderr, "UART failed to setup\n");
        return EXIT_FAILURE;
    }
    if(mraa_uart_set_baudrate(uart,115200)!=MRAA_SUCCESS)
    {
        fprintf(stderr,"Set Baud Failed\n");
    }
    for(i=1;i<=1;i++)
    {
        //msdelay(75);
        printf("value of i:%d",i);
        mraa_uart_write(uart, buffer, sizeof(buffer));
        if(mraa_uart_data_available(uart,25))
        {
            printf("entered into loop\n");
            rev=mraa_uart_read(uart,buff,sizeof(buff));
            buffptr += rev;
            printf("data received :%s\n",buff);
            printf("no of bytes:%d\n",rev);
            memset(buff,0x00,sizeof(buff));
        }
        else
        {
            printf("data not received");
        }
    }
    mraa_uart_stop(uart);
    mraa_deinit();
    return EXIT_SUCCESS;
}
